﻿using System;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace Feel.common
{
    class GlassDildo : MVRScript
    {
        private static float MaxWobble = 0.09f;
        private static float WobbleSpeed = 5.0f;
        private static float RecoveryRate = 5f;

        private static Vector3 prevPos;
        private static Vector3 prevRot;
        private static float wobbleAmountToAddX;
        private static float wobbleAmountToAddZ;

        private JSONStorableStringChooser _person_list;
        private UIDynamicPopup _person_select_pop;
        private JSONStorableStringChooser _orificeJSON;
        private UIDynamicPopup _orifice_select_pop;

        private Transform _dildo;
        private Transform _liquid_root;
        private Transform _Inglass_root;
        private Rigidbody _labiaTrigger;
        private Rigidbody _vaginaTrigger;
        private FreeControllerV3 _thisControl;

        protected JSONStorableFloat lockAngleX;
        protected JSONStorableFloat lockAngleY;
        protected JSONStorableFloat lockAngleZ;
        protected JSONStorableFloat lockPosX;
        protected JSONStorableFloat lockPosY;
        protected JSONStorableFloat lockPosZ;

        private JSONStorableFloat _liquid_height;
        private List<String> _orificePersonChoices;
        private JSONStorableBool _person_lock;
        private JSONStorableColor _ball_color;
        private JSONStorableColor _liquid_color;

        private float _motion_value;
        private float _motion_speed = 0.001f;
        private bool _motion_up;
        private JSONStorableBool _is_motion;
        private JSONStorableFloat _motion_speed_value;
        private JSONStorableFloat _motion_depth_value;
        //private JSONStorableVector3 _base_position;
        //private JSONStorableVector3 _base_rotate;

        protected JSONStorableFloat _basePosX;
        protected JSONStorableFloat _basePosY;
        protected JSONStorableFloat _basePosZ;
        protected JSONStorableFloat _baseAngleX;
        protected JSONStorableFloat _baseAngleY;
        protected JSONStorableFloat _baseAngleZ;

        private Atom _target_girl;

        private bool _is_init = false;
        private int _initLoops = 0;
        private readonly int _maxInitLoops = 1000;

        public override void Init()
        {
            try
            {
                if (containingAtom.type != "CustomUnityAsset")
                {
                    SuperController.LogError("GlassDildo - Not a usable environment." + containingAtom.type);
                    return;
                }

                _thisControl = containingAtom.freeControllers.First(fc => fc.name == "control");

                //_base_position = new JSONStorableVector3("BasePosition", _thisControl.transform.position, OnChangeData, new Vector3(-100f, -100f, -100f), new Vector3(100f, 100f, 100f));
                //RegisterVector3(_base_position);

                _basePosX = new JSONStorableFloat("BasePosX", 0f, -100f, 100f);
                RegisterFloat(_basePosX);
                _basePosY = new JSONStorableFloat("BasePosY", 0f, -100f, 100f);
                RegisterFloat(_basePosY);
                _basePosZ = new JSONStorableFloat("BasePosZ", 0f, -100f, 100f);
                RegisterFloat(_basePosZ);

                //_base_rotate = new JSONStorableVector3("BaseRotate", _thisControl.transform.rotation.eulerAngles, OnChangeData, Vector3.zero, new Vector3(360f, 360f, 360f));
                //RegisterVector3(_base_rotate);

                _baseAngleX = new JSONStorableFloat("BaseAngleX", 0f, 0f, 360f);
                RegisterFloat(_baseAngleX);
                _baseAngleY = new JSONStorableFloat("BaseAngleY", 0f, 0f, 360f);
                RegisterFloat(_baseAngleY);
                _baseAngleZ = new JSONStorableFloat("BaseAngleZ", 0f, 0f, 360f);
                RegisterFloat(_baseAngleZ);

                var save_btn = CreateButton("BasePosition Save");
                save_btn.button.onClick.AddListener(OnSavePosition);
                var load_btn = CreateButton("BasePosition Load");
                load_btn.button.onClick.AddListener(OnLoadPosition);

                JSONStorableAction position_reset_action = new JSONStorableAction("Position Reset", OnLoadPosition);
                RegisterAction(position_reset_action);

                _liquid_height = new JSONStorableFloat("Liquid Height", 0.5f, OnLiquidHeight, 0f, 1f);
                RegisterFloat(_liquid_height);
                CreateSlider(_liquid_height);

                var btn = CreateButton("Person Update");
                btn.button.onClick.AddListener(() =>
                {
                    UpdateAtomData();
                });

                _person_list = new JSONStorableStringChooser("Person Choice", null, null, "", OnChoicePerson);
                _person_list.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_person_list);

                _person_select_pop = CreateScrollablePopup(_person_list, false);
                _person_select_pop.popupPanelHeight = 800f;
                _person_select_pop.popup.onOpenPopupHandlers += () => {};
                _person_select_pop.label = "Person:";

                _orificePersonChoices = new List<string>();
                _orificePersonChoices.Add("Vagina");
                _orificePersonChoices.Add("Anus");

                _orificeJSON = new JSONStorableStringChooser("OrificeChoice", null, "Vagina", "", OrificeSelect);
                _orificeJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterStringChooser(_orificeJSON);
                _orificeJSON.choices = _orificePersonChoices;

                _orifice_select_pop = CreateScrollablePopup(_orificeJSON, false);
                _orifice_select_pop.popupPanelHeight = 200f;
                _orifice_select_pop.popup.onOpenPopupHandlers += () => { };
                _orifice_select_pop.label = "Target:";

                _person_lock = new JSONStorableBool("Person Lock", false, (bool is_lock) =>
                {
                    if (!is_lock) OnLoadPosition();
                });
                RegisterBool(_person_lock);
                CreateToggle(_person_lock);

                lockAngleX = new JSONStorableFloat("lock x rotation", 0f, OnChangeData, -180f, 180f);
                RegisterFloat(lockAngleX);
                CreateSlider(lockAngleX, true);
                lockAngleY = new JSONStorableFloat("lock y rotation", 0f, OnChangeData, -180f, 180f);
                RegisterFloat(lockAngleY);
                CreateSlider(lockAngleY, true);
                lockAngleZ = new JSONStorableFloat("lock z rotation", 0f, OnChangeData, -180f, 180f);
                RegisterFloat(lockAngleZ);
                CreateSlider(lockAngleZ, true);
                lockPosX = new JSONStorableFloat("lock x position", 0f, OnChangeData, -1f, 1f);
                RegisterFloat(lockPosX);
                CreateSlider(lockPosX, true);
                lockPosY = new JSONStorableFloat("lock y position", -0.4f, OnChangeData, -1f, 1f);
                RegisterFloat(lockPosY);
                CreateSlider(lockPosY, true);
                lockPosZ = new JSONStorableFloat("lock z position", 0f, OnChangeData, -1f, 1f);
                RegisterFloat(lockPosZ);
                CreateSlider(lockPosZ, true);

                HSVColor color = new HSVColor();
                color.H = 1f;
                color.S = 0f;
                color.V = 1f;
                _ball_color = new JSONStorableColor("Bag Shell Color", color, OnChangeBallColor);
                RegisterColor(_ball_color);
                CreateColorPicker(_ball_color);

                CreateSpacer();

                _is_motion = new JSONStorableBool("Motion", false);
                RegisterBool(_is_motion);
                CreateToggle(_is_motion);

                _motion_speed_value = new JSONStorableFloat("Motion Speed", 0f, OnMotionSpeed, 0f, 1f);
                RegisterFloat(_motion_speed_value);
                CreateSlider(_motion_speed_value, false);

                _motion_depth_value = new JSONStorableFloat("Motion Depth", 1f, (float value) => {}, 0f, 1f);
                RegisterFloat(_motion_depth_value);
                CreateSlider(_motion_depth_value, false);

                // A tiny bit of help to give some info to your fellow creator and/or player
                JSONStorableString helpText = new JSONStorableString("About",
                    "<color=#000><size=35><b>GlassDildo</b></size></color>\n\n" +
                    "<color=#333>" +
                    "It is a dildo that can be controlled.\n\n" +
                    "thank you for your support\n" +
                    "<b>https://www.patreon.com/feel_vam</b>\n\n" +
                    "</color>");
                UIDynamic helpTextfield = CreateTextField(helpText, true);
                helpTextfield.height = 300.0f;

                var btn1 = CreateButton("Go To Support", true);
                btn1.button.onClick.AddListener(() =>
                {
                    Application.OpenURL("https://www.patreon.com/feel_vam");
                });
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void OnChangeData(Vector3 value)
        {

        }

        private void OnChoicePerson(string target)
        {
            _target_girl = SuperController.singleton.GetAtomByUid(_person_list.val);
            _labiaTrigger = _target_girl.rigidbodies.First(rb => rb.name == "LabiaTrigger");
            _vaginaTrigger = _target_girl.rigidbodies.First(rb => rb.name == "VaginaTrigger");

        }

        private void OnSavePosition()
        {
            if (!SuperController.singleton.isLoading)
            {
                //_base_position.val = _thisControl.transform.position;
                //_base_rotate.val = _thisControl.transform.rotation.eulerAngles;

                _basePosX.val = _thisControl.transform.position.x;
                _basePosY.val = _thisControl.transform.position.y;
                _basePosZ.val = _thisControl.transform.position.z;
                _baseAngleX.val = _thisControl.transform.rotation.eulerAngles.x;
                _baseAngleY.val = _thisControl.transform.rotation.eulerAngles.y;
                _baseAngleZ.val = _thisControl.transform.rotation.eulerAngles.z;

            }
        }

        private void OnLoadPosition()
        {
            if (!SuperController.singleton.isLoading && _basePosX != null)
            {
                //SuperController.LogMessage("->> " + _base_position.val);
                _thisControl.transform.position = new Vector3(_basePosX.val, _basePosY.val, _basePosZ.val);
                Quaternion r = _thisControl.transform.rotation;
                r.eulerAngles = new Vector3(_baseAngleX.val, _baseAngleY.val, _baseAngleZ.val);
                _thisControl.transform.rotation = r;

            }
        }

        private void OnMotionSpeed(float value)
        {
            _motion_speed = (0.02f * value) + 0.001f;
        }

        private void OnChangeBallColor(JSONStorableColor color)
        {
            if(_Inglass_root != null)
            {
                Renderer renderer = _Inglass_root.GetComponent<Renderer>();
                Color ma_color = Color.HSVToRGB(color.val.H, color.val.S, color.val.V);
                renderer.material.color = ma_color;
            }
        }

        void OnChangeData(float value)
        {

        }

        protected void OrificeSelect(string target_name)
        {
            
        }

        private void UpdateAtomData()
        {
            List<string> atomChoices = new List<string>();
            Atom atom;
            foreach (string atomUID in SuperController.singleton.GetAtomUIDs())
            {
                atom = SuperController.singleton.GetAtomByUid(atomUID);
                JSONStorable geometry = atom.GetStorableByID("geometry");
                if (geometry != null)
                {
                    atomChoices.Add(atomUID);
                }
            }

            _person_list.choices = atomChoices;
        }

        private void OnLiquidHeight(float value)
        {
            if (_liquid_root == null) return;
            Renderer renderer = _liquid_root.GetComponent<Renderer>();
            float n = 0.65f - (value * 0.32f);
            //n = 0.5f;
            renderer.material.SetFloat("_FillAmount", n);
        }

        void Update()
        {
            if(_is_init)
            {
                Renderer render = _liquid_root.GetComponent<Renderer>();
                UpdateLiquidPhysics(_liquid_root, render);

            }
            if (_initLoops < _maxInitLoops)
            {
                _initLoops++;
                FirstInit();
            }
            else
            {
                if (_initLoops == 1001)
                {
                    SuperController.LogError("GlassDildo Load Failure " + _initLoops);
                    _initLoops += 1;
                }
            }
        }

        void FixedUpdate()
        {
            bool isl = SuperController.singleton.isLoading;
            if (!isl)
            {
                if (_person_lock.val && _person_list.val != null && _person_list.val != "")
                {
                    if (_target_girl != null)
                    {
                        if (_is_motion.val)
                        {
                            if (_motion_value < -0.1f * _motion_depth_value.val) _motion_up = true;
                            if (_motion_value > 0f) _motion_up = false;
                            if (_motion_up)
                                _motion_value += _motion_speed;
                            else
                                _motion_value -= _motion_speed;
                        }
                        else
                        {
                            _motion_value = 0f;
                        }

                        //_thisControl.transform.position = _labiaTrigger.transform.position;
                        //_thisControl.transform.rotation = Quaternion.LookRotation(_vaginaTrigger.transform.position - _labiaTrigger.transform.position, _labiaTrigger.transform.up);
                        //_thisControl.transform.Rotate(new Vector3(90f, 0f, 0f));

                        if (_orificeJSON.val == "Vagina")
                        {
                            _thisControl.transform.position = _labiaTrigger.transform.position;
                            _thisControl.transform.rotation = Quaternion.LookRotation(_vaginaTrigger.transform.position - _labiaTrigger.transform.position, _labiaTrigger.transform.up);
                        }

                        if (_orificeJSON.val == "Anus")
                        {
                            Transform anusTransform = _thisControl.transform;

                            _thisControl.transform.position = _labiaTrigger.transform.position;
                            _thisControl.transform.rotation = Quaternion.LookRotation(_vaginaTrigger.transform.position - _labiaTrigger.transform.position, _labiaTrigger.transform.up);

                            Vector3 anusOffsetPosition = new Vector3(0.0f, -0.045f, 0.008f);
                            anusTransform.Translate(anusOffsetPosition, anusTransform);

                            _thisControl.transform.position = anusTransform.position;
                            _thisControl.transform.rotation = anusTransform.rotation;

                            _thisControl.transform.rotation = Quaternion.LookRotation(_vaginaTrigger.transform.position - anusTransform.position, anusTransform.up);

                        }
                        _thisControl.transform.Rotate(new Vector3(90f, 0f, 0f));

                        Vector3 offsetPosition = new Vector3(lockPosX.val / 5f, (lockPosY.val / 5f) + _motion_value, lockPosZ.val / 5f);
                        _thisControl.transform.Translate(offsetPosition, _thisControl.transform);

                        _thisControl.transform.Rotate(lockAngleX.val, lockAngleY.val, lockAngleZ.val);

                    }
                    else
                    {
                        _motion_value = 0f;
                    }

                }
                else
                {
                    _motion_value = 0f;
                }
                
            }
        }

        private void FirstInit()
        {
            bool isl = SuperController.singleton.isLoading;
            if (isl) return;

            _dildo = getObjectRoot(containingAtom.reParentObject.transform, "glass_dildo");
            if (_dildo != null)
            {
                _liquid_root = getChildRoot(_dildo, "Liquid.001");
                _Inglass_root = getChildRoot(_dildo, "InGlass");

                //OnLoadPosition();
                UpdateAtomData();
                OnLiquidHeight(_liquid_height.val);

                if (_person_list.choices.Count > 0)
                {
                    OnChoicePerson(_person_list.val);
                }

                if (_basePosX.val == 0f && _basePosY.val == 0f && _basePosZ.val == 0f) OnSavePosition();

                _is_init = true;
                _initLoops += 1001;
            }

        }

        public static Transform getObjectRoot(Transform parent, string rootName)
        {
            foreach (Transform child in parent)
            {
                if (child.name.Contains(rootName))
                {
                    return child;
                }
                else
                {
                    Transform childSearch = getObjectRoot(child, rootName);
                    if (childSearch != null) return childSearch;
                }
            }

            return null;
        }

        public static Transform getChildRoot(Transform parent, string searchName)
        {
            foreach (Transform child in parent)
            {
                if (child.name == searchName)
                {

                    return child;
                }
                else
                {
                    Transform childSearch = getChildRoot(child, searchName);
                    if (childSearch != null) return childSearch;
                }
            }

            return null;
        }

        public void UpdateLiquidPhysics(Transform LiquidRoot, Renderer rend)
        {
            wobbleAmountToAddX = Mathf.Lerp(wobbleAmountToAddX, 0, Time.deltaTime * RecoveryRate);
            wobbleAmountToAddZ = Mathf.Lerp(wobbleAmountToAddZ, 0, Time.deltaTime * RecoveryRate);

            // make a sine wave of the decreasing wobble
            float wobbleAmountX = wobbleAmountToAddX * Mathf.Sin(WobbleSpeed * Time.time);
            float wobbleAmountZ = wobbleAmountToAddZ * Mathf.Sin(WobbleSpeed * Time.time);

            // send it to the shader
            rend.material.SetFloat("_WobbleX", wobbleAmountX);
            rend.material.SetFloat("_WobbleZ", wobbleAmountZ);

            // Move Speed
            Vector3 moveSpeed = (prevPos - LiquidRoot.position) / Time.deltaTime;
            Vector3 rotationDelta = LiquidRoot.rotation.eulerAngles - prevRot;

            // add clamped speed to wobble
            wobbleAmountToAddX += Mathf.Clamp((moveSpeed.x + (rotationDelta.z * 0.5f)) * MaxWobble, -MaxWobble, MaxWobble);
            wobbleAmountToAddZ += Mathf.Clamp((moveSpeed.z + (rotationDelta.x * 0.5f)) * MaxWobble, -MaxWobble, MaxWobble);

            // save the last position
            prevPos = LiquidRoot.position;
            prevRot = LiquidRoot.rotation.eulerAngles;

        }
    }
}
